program Project1;
uses
  Interfaces, Forms, Controls, Classes;

type
  TApp = class(TObject)
  private
    Form: TForm;
    procedure KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure KeyPress(Sender: TObject; var Key: char);
  public
    constructor Create;
    destructor Destroy; override;
    procedure Run;
  end;

  procedure TApp.KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
  begin
    WriteLn(Key);
  end;

  procedure TApp.KeyPress(Sender: TObject; var Key: char);
  begin
    WriteLn(Key);
  end;

  constructor TApp.Create;
  begin
    inherited Create;
    Form := TForm.Create(nil);
    Form.OnKeyDown := @KeyDown;
    Form.OnKeyPress := @KeyPress;
  end;

  destructor TApp.Destroy;
  begin
    Form.Free;
    inherited Destroy;
  end;

  procedure TApp.Run;
  begin
    Form.ShowModal;
  end;

var
  App: TApp;
begin
  App := TApp.Create;
  App.Run;
  App.Free;
end.
